From f1ad3f4b80ad0f7bec0604fb7187880c367d0451 Mon Sep 17 00:00:00 2001
From: Thomas Munro <thomas.munro@gmail.com>
Date: Sat, 27 Apr 2024 13:57:55 +1200
Subject: [PATCH v2 11/11] Use streaming I/O in DELETE via write-behind. XXX

XXX This changes heapam.c to use BAS_BULKWRITE.  Perhaps we really want
an adaptive-size ring strategy, that starts as BAS_BULKREAD, but expands
towards BAS_BULKWRITE size when it hits dirty data?
---
 src/backend/access/heap/heapam.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index a8055087dca..6e9720af7e1 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -340,7 +340,7 @@ initscan(HeapScanDesc scan, ScanKey key, bool keep_startblock)
 	{
 		/* During a rescan, keep the previous strategy object. */
 		if (scan->rs_strategy == NULL)
-			scan->rs_strategy = GetAccessStrategy(BAS_BULKREAD);
+			scan->rs_strategy = GetAccessStrategy(BAS_BULKWRITE); /* XXX hack */
 	}
 	else
 	{
@@ -588,7 +588,7 @@ heap_fetch_next_buffer(HeapScanDesc scan, ScanDirection dir)
 	/* release previous scan buffer, if any */
 	if (BufferIsValid(scan->rs_cbuf))
 	{
-		ReleaseBuffer(scan->rs_cbuf);
+		StrategyReleaseBuffer(scan->rs_strategy, scan->rs_cbuf);
 		scan->rs_cbuf = InvalidBuffer;
 	}
 
-- 
2.44.0

